#include <iostream>
using namespace std;

int main() {
    while (true) {
        int n;
        // Leitura do número n
        cin >> n;

        // Interrompe se n for 0
        if (n == 0) {
            break;
        }

        // Calcula o vetor de resposta
        int resp[4];
        if (n == 2) {
            resp[0] = 0;
            resp[1] = 0;
            resp[2] = 0;
            resp[3] = 8;
        } else {
            resp[0] = (n - 2) * (n - 2) * (n - 2);
            resp[1] = 6 * (n - 2) * (n - 2);
            resp[2] = 12 * (n - 2);
            resp[3] = 8;
        }

        // Imprime o vetor de resposta
        for (int i = 0; i < 4; i++) {
            cout << resp[i] << endl;
        }
    }

    return 0;
}
